/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/********************************************************************/
/********************************************************************/
#pragma once

#include "resource.h"
#include "GLPropPanel.h"
#include "afxcmn.h"

// fugenViewPropPane ダイアログ
///ビュー設定ダイアログ
class fugenViewPropPane : public CGLPropPane
{
	// 非 DDX/DDV パラメータ
	double m_dRotMin, m_dRotMax;
	double m_dTrans, m_dTransMin, m_dTransMax;
	double m_dZoom, m_dZoomMin, m_dZoomMax;

public:
	//fugenViewPropPane(CGLPropDialog* propPanel=0);
	fugenViewPropPane(fugenDoc* pDoc);

	// ダイアログ データ
	///ビュー設定ダイアログID
	enum { IDD = IDD_PROP_VIEW };
	///パンの移動量設定-スライダー
	CSliderCtrl m_sldPanRatio;
	///true=キーボードによる移動の方向を反転する
	BOOL m_bPanFlip;
	///true=右マウスボタンで平行ビューを常にパンする
	BOOL m_bPanAlways;
	///ズームの倍率設定-スライダー
	CSliderCtrl m_sldZoomRatio;
	///回転増分-スピンコントロール
	CSpinButtonCtrl m_spnRot;
	///回転増分-テキスト
	double m_dRot;
	///true=キーボードによる回転方向を反転する
	BOOL m_bRotFlip;

	//virtual void LoadUserProf();

	//デフォルト値設定
	void fugenViewPropPane::OnButtonPropViewDefault();

	// オーバーライド
	// ClassWizard は仮想関数のオーバーライドを生成します。
	//{{AFX_VIRTUAL(CGLDisplayPropPane)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート
	//}}AFX_VIRTUAL

	// インプリメンテーション
protected:

	// 生成されたメッセージ マップ関数
	//{{AFX_MSG(fugenViewPropPane)
	afx_msg void OnDeltaposSpin(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//virtual void DoCheckProp(CGLPropDialog& panel);
	//virtual void DoInitProp(const CGLPropDialog& panel);

	virtual void LoadUserProf();
	virtual BOOL UpdateUserProf();
	virtual void ResetToDefaultUserProf();

	virtual void LoadDocContext();
	virtual BOOL UpdateDocContext();
	virtual void ResetToDefaultDocContext();

};
